SystemOrganization addCategory: #ProxiesTests!

!CompiledMethodProxyReferenceStreamWithFileName methodsFor: '*ProxiesTests' stamp: 'MarianoMartinezPeck 10/28/2010 00:01'!
fooSomething
	^ 'fooSomethingProxy'! !

TestCase subclass: #AbstractCompiledMethodProxyTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProxiesTests'!

!AbstractCompiledMethodProxyTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/20/2010 18:21'!
installCompiledMethodProxyOn: aClass selector: aSelector
	^ self proxyClass installOn: aClass selector: aSelector.! !

!AbstractCompiledMethodProxyTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/20/2010 18:21'!
proxyClass
	^ self subclassResponsibility ! !

!AbstractCompiledMethodProxyTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/20/2010 18:11'!
proxyClassName
	^ self proxyClass name! !

!AbstractCompiledMethodProxyTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/20/2010 23:56'!
tearDown
	(FileDirectory default fileNamesMatching: '*a CompiledMethod(*') 
		do: [ :aFile | FileDirectory default deleteFileNamed: aFile ].
	(FileDirectory default fileNamesMatching: '*.swap') 
		do: [ :aFile | FileDirectory default deleteFileNamed: aFile ].! !

!AbstractCompiledMethodProxyTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/20/2010 18:59'!
testCompiledMethodMessageSent
	"A simple CompiledMethodProxy test"
	| aProxy |
	
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	[self assert: ((ClassWith1Var methodDict mareaAt: #foo) class name = self proxyClassName).
	"Notice that in this case we are not executing the CompiledMethod but instead, sending messages to it.
	In this case, the original method should be back also."
	self assert: (ClassWith1Var methodDict mareaAt: #foo) literals size = 3.
	self assert: ((ClassWith1Var methodDict mareaAt: #foo) class name = #CompiledMethod).
	] ensure: [ aProxy mareaUninstallForClass: ClassWith1Var selector: #foo].


! !

!AbstractCompiledMethodProxyTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/20/2010 18:59'!
testCompiledMethodMessageSentByPerform
	"A simple CompiledMethodProxy test"
	| aProxy |
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	[self assert: ((ClassWith1Var methodDict mareaAt: #foo) class name = self proxyClassName).
	"Notice that in this case we are not executing the CompiledMethod but instead, sending messages to it.
	In this case, the original method should be back also."
	self assert: ((ClassWith1Var methodDict mareaAt: #foo) perform: #literals) size = 3.
	self assert: ((ClassWith1Var methodDict mareaAt: #foo) class name = #CompiledMethod).
	] ensure: [ aProxy mareaUninstall].


! !

!AbstractCompiledMethodProxyTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/20/2010 18:59'!
testCompiledMethodMessageSentByPerformWith
	"A simple CompiledMethodProxy test"
	| aProxy |
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo:.
	[self assert: ((ClassWith1Var methodDict mareaAt: #foo:) class name = self proxyClassName).
	"Notice that in this case we are not executing the CompiledMethod but instead, sending messages to it.
	In this case, the original method should be back also."
	self assert: ((ClassWith1Var methodDict mareaAt: #foo:) perform: #literals) size = 3.
	self assert: ((ClassWith1Var methodDict mareaAt: #foo:) class name = #CompiledMethod).
	] ensure: [ aProxy mareaUninstall].


! !

!AbstractCompiledMethodProxyTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/20/2010 18:59'!
testCompiledMethodMessageSentByPerformWithNotUnderstood
	"A simple CompiledMethodProxy test"
	| aProxy |
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	[self assert: ((ClassWith1Var methodDict mareaAt: #foo) class name = self proxyClassName).
	"Notice that in this case we are not executing the CompiledMethod but instead, sending messages to it.
	In this case, the original method should be back also."
	self should: [(ClassWith1Var methodDict mareaAt: #foo) perform: #nonExistentMethod] raise: Error.
	self assert: ((ClassWith1Var methodDict mareaAt: #foo) class name = #CompiledMethod).
	] ensure: [ aProxy mareaUninstall].


! !

!AbstractCompiledMethodProxyTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/20/2010 18:59'!
testCompiledMethodMessageSentByPerformWithNotUnderstood2
	"A simple CompiledMethodProxy test"
	| aProxy |
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	[self assert: ((ClassWith1Var methodDict mareaAt: #foo) class name = self proxyClassName).
	"Notice that in this case we are not executing the CompiledMethod but instead, sending messages to it.
	In this case, the original method should be back also." 
	self should: [(ClassWith1Var methodDict mareaAt: #foo) perform: #fooDNU] raise: Error.
	self assert: ((ClassWith1Var methodDict mareaAt: #foo) class name = #CompiledMethod).
	] ensure: [ aProxy mareaUninstall].


! !

!AbstractCompiledMethodProxyTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/20/2010 18:59'!
testCompiledMethodProxy
	"A simple CompiledMethodProxy test"
	| aProxy |
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	[self assert: ((ClassWith1Var methodDict mareaAt: #foo) class name = self proxyClassName).
	self assert: (ClassWith1Var new foo = 'foo').
	self assert: ((ClassWith1Var methodDict mareaAt: #foo) class name = #CompiledMethod).
	] ensure: [ aProxy mareaUninstall].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/20/2010 18:59'!
testCompiledMethodProxyAndGC
	"A simple CompiledMethodProxy test"
	| aProxy methodsInstCountFirst  methodsInstCountEnd |
	MCMethodDefinition shutDown. 
	3 timesRepeat: [Smalltalk garbageCollect].
	methodsInstCountFirst := CompiledMethod instanceCount.
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	[self assert: ((ClassWith1Var methodDict mareaAt: #foo) class name = self proxyClassName).
	"This line is important because the MCMethodDefinition have references to the CompiledMethod"
	MCMethodDefinition shutDown. 
	3 timesRepeat: [Smalltalk garbageCollect].
	methodsInstCountEnd := CompiledMethod instanceCount.
	self assert: ((methodsInstCountFirst - 1) = methodsInstCountEnd).
	self assert: (ClassWith1Var new foo = 'foo').
	self assert: ((ClassWith1Var methodDict mareaAt: #foo) class name = #CompiledMethod).  
	] ensure: [
		aProxy mareaUninstall.
		MCMethodDefinition shutDown. 
		Smalltalk garbageCollect].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/20/2010 18:59'!
testCompiledMethodProxyAndPerform
	"A simple CompiledMethodProxy test"
	| aProxy |
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	[self assert: ((ClassWith1Var methodDict mareaAt: #foo) class name = self proxyClassName).
	self assert: ((ClassWith1Var new perform: #foo) = 'foo').
	self assert: ((ClassWith1Var methodDict mareaAt: #foo) class name = #CompiledMethod).
	] ensure: [ aProxy mareaUninstall].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/20/2010 22:57'!
testCompiledMethodProxyAndPerformWith
	"A simple CompiledMethodProxy test"
	| aProxy |
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo:.
	[ self assert: ((ClassWith1Var methodDict mareaAt: #foo:) class name = self proxyClassName).
	self assert: (ClassWith1Var new perform: #foo: with: 2) = 'foo'.
	self assert: ((ClassWith1Var methodDict mareaAt: #foo:) class name = #CompiledMethod).
	] ensure: [ aProxy mareaUninstall].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/20/2010 18:59'!
testCompiledMethodProxyAndPerformWithNotUnderstood2
	"A simple CompiledMethodProxy test"
	| aProxy |
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #fooDNU.
	[self assert: ((ClassWith1Var methodDict mareaAt: #fooDNU) class name = self proxyClassName).
	self should: [ClassWith1Var new perform: #fooDNU ] raise: Error. 
	self assert: ((ClassWith1Var methodDict mareaAt: #fooDNU) class name = #CompiledMethod).
	] ensure: [ aProxy mareaUninstall].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/20/2010 18:59'!
testCompiledMethodProxyDifficult
	"A simple CompiledMethodProxy test"
	| aProxy |
	
	aProxy := self installCompiledMethodProxyOn: TestRunner selector: #addMethodsUnderTestIn:to:.
	[self assert: ((TestRunner methodDict mareaAt: #addMethodsUnderTestIn:to:) class name = self proxyClassName).
	TestRunner new addMethodsUnderTestIn: (Array with: (PackageInfo named: 'VMMaker')) to: (OrderedCollection with: CompiledMethod toReturnSelf).
	self assert: ((TestRunner methodDict mareaAt: #addMethodsUnderTestIn:to:) class name = #CompiledMethod).
	] ensure: [ aProxy mareaUninstall].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/20/2010 23:25'!
testCompiledMethodProxyFlushCache
	"A simple CompiledMethodProxy test"
	| aProxy anObject |
	anObject := ClassWith1Var new. 
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #fooSomething.
	[self assert: ((ClassWith1Var methodDict mareaAt: #fooSomething) class name = self proxyClassName).
	self assert: (anObject fooSomething = 'fooSomething').
	self assert: (anObject fooSomething = 'fooSomething').
	self assert: ((ClassWith1Var methodDict mareaAt: #fooSomething) class name = #CompiledMethod).
	self assert: (anObject fooSomething = 'fooSomething').
	] ensure: [ aProxy mareaUninstall].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/19/2010 22:28'!
testCompiledMethodWithReferenceStream
	"A simple CompiledMethodProxy test"
	| aCompiledMethod refStream newCompiledMethod aFileName |
	
	aCompiledMethod := ClassWith1Var >> #foo.
	self assert: (ClassWith1Var new foo = 'foo').
	
	aFileName := String streamContents: [ :stream | aCompiledMethod printOn: stream ].
	refStream := ReferenceStream fileNamed: aFileName.
	refStream nextPut: aCompiledMethod.
	refStream close.
	
	refStream := ReferenceStream fileNamed: aFileName.
	newCompiledMethod := refStream next.
	refStream close.
	
	[
	ClassWith1Var methodDict at: #foo put: newCompiledMethod.
	self assert: (ClassWith1Var new foo = 'foo').
	] ensure: [ ClassWith1Var methodDict at: #foo put: aCompiledMethod..].
! !

AbstractCompiledMethodProxyTest subclass: #CompiledMethodProxyReferenceStreamSmallIntegerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProxiesTests'!

!CompiledMethodProxyReferenceStreamSmallIntegerTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/20/2010 18:23'!
proxyClass
	^ SmallInteger! !

AbstractCompiledMethodProxyTest subclass: #CompiledMethodProxyReferenceStreamWithFileNameTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProxiesTests'!

!CompiledMethodProxyReferenceStreamWithFileNameTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/20/2010 18:21'!
proxyClass
	^ CompiledMethodProxyReferenceStreamWithFileName! !

TestCase subclass: #ClassProxyFileOutTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProxiesTests'!

!ClassProxyFileOutTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/15/2010 19:53'!
testClassSwapRestoreByClass
	"This is a more complex test with several asserts. The important thing in this test is that the original class is restored while sending a message directly to the class"
	| inst proxy |
	inst := ClassWith1Var new.
	self assert: inst foo = 'foo'.
	self assert: inst class = ClassWith1Var.
	proxy := ClassProxyFileOut new.
	"I cannot do a becomeForward:   it has to be a become, since in the proxy I have an instVar pointing to self which will then updated to the class"
	proxy become: ClassWith1Var.
	
	"The following 2 lines freezes the image in case the Proxy extends from ProtoObject instead of Object"
"	self assert: inst class == proxy.
	Transcript show: ClassWith1Var name; cr."
	
	"All the following asserts are based in the assumption that it was a become: and not a becomeForward:"
	
	"ClassWith1Var class was replaced by an instance of ClassProxyInstVar"
	self assert: ClassWith1Var class name = #ClassProxyFileOut.
	self assert: inst class class name =  #ClassProxyFileOut.
	self assert: inst class class class isMeta.
	self assert: proxy class isMeta.
	self assert: proxy name = #ClassWith1Var.
	

	"When seding any message that is not understood to the proxy, the original class is restored"
	ClassWith1Var format.
	
	self assert: ClassWith1Var name = #ClassWith1Var.
	self assert: inst class class isMeta.
	self assert: inst class name =  #ClassWith1Var.
	self assert: proxy class name = #ClassProxyFileOut.

! !

!ClassProxyFileOutTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/15/2010 19:54'!
testClassSwapRestoreByInstances
	"This is a more complex test with several asserts. The important thing in this test is that the original class is restored while sending a message to an instance of it."
	| inst proxy |
	inst := ClassWith1Var new.
	self assert: inst foo = 'foo'.
	self assert: inst class = ClassWith1Var.
	proxy := ClassProxyFileOut new.
	"I cannot do a becomeForward:   it has to be a become, since in the proxy I have an instVar pointing to self which will then updated to the class"
	proxy become: ClassWith1Var.
	
	"The following 2 lines freezes the image in case the Proxy extends from ProtoObject instead of Object"
"	self assert: inst class == proxy.
	Transcript show: ClassWith1Var name; cr."
	
	"All the following asserts are based in the assumption that it was a become: and not a becomeForward:"
	
	"ClassWith1Var class was replaced by an instance of ClassProxyInstVar"
	self assert: ClassWith1Var class name = #ClassProxyFileOut.
	self assert: inst class class name =  #ClassProxyFileOut.
	self assert: inst class class class isMeta.
	self assert: proxy class isMeta.
	self assert: proxy name = #ClassWith1Var.
	

	"With this #foo the proxy and the class are restored"
	self assert: inst foo = 'foo'.
	
	self assert: ClassWith1Var name = #ClassWith1Var.
	self assert: inst class class isMeta.
	self assert: inst class name =  #ClassWith1Var.
	self assert: proxy class name = #ClassProxyFileOut.

! !

!ClassProxyFileOutTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/15/2010 19:54'!
testClassSwapSimple
	| inst proxy |
	"This is the simplest test that does the less assert as possible."
	inst := ClassWith1Var new.
	self assert: inst foo = 'foo'.
	proxy := ClassProxyFileOut new.
	proxy become: ClassWith1Var.
	self assert: (inst class == ClassWith1Var).
	self assert: inst foo = 'foo'.
! !

TestCase subclass: #ClassProxyInstVarTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProxiesTests'!

!ClassProxyInstVarTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/15/2010 19:10'!
testClassSwapRestoreByClass
	"This is a more complex test with several asserts. The important thing in this test is that the original class is restored while sending a message directly to the class"
	| inst proxy |
	inst := ClassWith1Var new.
	self assert: inst foo = 'foo'.
	self assert: inst class = ClassWith1Var.
	proxy := ClassProxyInstVar new.
	"I cannot do a becomeForward:   it has to be a become, since in the proxy I have an instVar pointing to self which will then updated to the class"
	proxy become: ClassWith1Var.
	
	"The following 2 lines freezes the image in case the Proxy extends from ProtoObject instead of Object"
"	self assert: inst class == proxy.
	Transcript show: ClassWith1Var name; cr."
	
	"All the following asserts are based in the assumption that it was a become: and not a becomeForward:"
	
	"ClassWith1Var class was replaced by an instance of ClassProxyInstVar"
	self assert: ClassWith1Var class name = #ClassProxyInstVar.
	self assert: inst class class name =  #ClassProxyInstVar.
	self assert: inst class class class isMeta.
	self assert: proxy class isMeta.
	self assert: proxy name = #ClassWith1Var.
	

	"When seding any message that is not understood to the proxy, the original class is restored"
	ClassWith1Var format.
	
	self assert: ClassWith1Var name = #ClassWith1Var.
	self assert: inst class class isMeta.
	self assert: inst class name =  #ClassWith1Var.
	self assert: proxy class name = #ClassProxyInstVar.

! !

!ClassProxyInstVarTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/15/2010 19:09'!
testClassSwapRestoreByInstances
	"This is a more complex test with several asserts. The important thing in this test is that the original class is restored while sending a message to an instance of it."
	| inst proxy |
	inst := ClassWith1Var new.
	self assert: inst foo = 'foo'.
	self assert: inst class = ClassWith1Var.
	proxy := ClassProxyInstVar new.
	"I cannot do a becomeForward:   it has to be a become, since in the proxy I have an instVar pointing to self which will then updated to the class"
	proxy become: ClassWith1Var.
	
	"The following 2 lines freezes the image in case the Proxy extends from ProtoObject instead of Object"
"	self assert: inst class == proxy.
	Transcript show: ClassWith1Var name; cr."
	
	"All the following asserts are based in the assumption that it was a become: and not a becomeForward:"
	
	"ClassWith1Var class was replaced by an instance of ClassProxyInstVar"
	self assert: ClassWith1Var class name = #ClassProxyInstVar.
	self assert: inst class class name =  #ClassProxyInstVar.
	self assert: inst class class class isMeta.
	self assert: proxy class isMeta.
	self assert: proxy name = #ClassWith1Var.
	

	"With this #foo the proxy and the class are restored"
	self assert: inst foo = 'foo'.
	
	self assert: ClassWith1Var name = #ClassWith1Var.
	self assert: inst class class isMeta.
	self assert: inst class name =  #ClassWith1Var.
	self assert: proxy class name = #ClassProxyInstVar.

! !

!ClassProxyInstVarTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/15/2010 19:08'!
testClassSwapSimple
	| inst proxy |
	"This is the simplest test that does the less assert as possible."
	inst := ClassWith1Var new.
	self assert: inst foo = 'foo'.
	proxy := ClassProxyInstVar new.
	proxy become: ClassWith1Var.
	self assert: (inst class == ClassWith1Var).
	self assert: inst foo = 'foo'.
! !

TestCase subclass: #CompiledMethodProxyTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProxiesTests'!

!CompiledMethodProxyTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/23/2010 19:07'!
testCompiledMethodMessageSent
	"A simple CompiledMethodProxy test"
	| aProxy |
	aProxy := CompiledMethodProxy installOn: ClassWith1Var selector: #foo.
	[self assert: ((ClassWith1Var methodDict at: #foo) class name = #CompiledMethodProxy).
	self deny: aProxy mareaExecuted.
	"Notice that in this case we are not executing the CompiledMethod but instead, sending messages to it.
	In this case, the original method should be back also."
	self assert: (ClassWith1Var methodDict at: #foo) literals size = 3.
	self assert: ((ClassWith1Var methodDict at: #foo) class name = #CompiledMethod).
	self deny: aProxy mareaExecuted.  
	] ensure: [ aProxy mareaUninstall].



! !

!CompiledMethodProxyTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/23/2010 19:07'!
testCompiledMethodProxy
	"A simple CompiledMethodProxy test"
	| aProxy |
	aProxy := CompiledMethodProxy installOn: ClassWith1Var selector: #foo.
	[self assert: ((ClassWith1Var methodDict at: #foo) class name = #CompiledMethodProxy).
	self deny: aProxy mareaExecuted.
	self assert: (ClassWith1Var new foo = 'foo').
	self assert: ((ClassWith1Var methodDict at: #foo) class name = #CompiledMethod).
	self assert: aProxy mareaExecuted.  
	] ensure: [ aProxy mareaUninstall].

! !

!CompiledMethodProxyTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/23/2010 19:07'!
testCompiledMethodProxyAndGC
	"A simple CompiledMethodProxy test"
	| aProxy methodsInstCountFirst  methodsInstCountEnd |
	methodsInstCountFirst := CompiledMethod instanceCount.
	aProxy := CompiledMethodProxy installOn: ClassWith1Var selector: #foo.
	[self assert: ((ClassWith1Var methodDict at: #foo) class name = #CompiledMethodProxy).
	"This line is important because the MCMethodDefinition have references to the CompiledMethod.
	It is important to notice that the old CompiledMethod is never garbage collected since this proxy has a reference 	to it."
	MCMethodDefinition shutDown. 
	Smalltalk garbageCollect.
	methodsInstCountEnd := CompiledMethod instanceCount.
	self deny: ((methodsInstCountFirst - 1) = methodsInstCountEnd).
	self deny: aProxy mareaExecuted.
	self assert: (ClassWith1Var new foo = 'foo').
	self assert: ((ClassWith1Var methodDict at: #foo) class name = #CompiledMethod).
	self assert: aProxy mareaExecuted.  
	] ensure: [ aProxy mareaUninstall].
! !

TestCase subclass: #ObjectProxyTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProxiesTests'!

!ObjectProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 10/16/2010 21:35'!
XXXXtestOneClassObjectsInner
		
	| b a proxy |
	
	b := ClassWith2Var. 
	a := ClassWith1Var new var1: b.
	
	"We put a proxy and become for B."
	ObjectSwapper new swap: b.
	Transcript show: 'antes';cr.
	self assert: a var1 name = AClassProxy name. 
	Transcript show: 'desp';cr.
	a var1 new class.
	self assert: a var1 new class = ClassWith2Var.
	Transcript show: 'mas desp';cr.
	self assert: a var1 class = ClassWith2Var. 
	Transcript show: 'ree desp';cr.! !

!ObjectProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 10/21/2010 19:08'!
tearDown
	(FileDirectory default fileNamesMatching: '*.swap') 
		do: [ :aFile | FileDirectory default deleteFileNamed: aFile ].! !

!ObjectProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 10/21/2010 18:28'!
testAllNomralObjectsAllInner
	"A points to B which is an array that points to C and D. All are normal and inner objects"	
	| c d b a proxy fileName hello today initialInstances finalInstances |
	
	hello := 'Hello'.
	today := Date today.
	
	c := ClassWith1Var new var1: hello.
	d := ClassWith1Var new var1: today.
	b := Array with: c with: d.
	a := ClassWith1Var new var1: b.
	
	3 timesRepeat: [Smalltalk garbageCollect].
	initialInstances := ClassWith1Var instanceCount. 
	d := c := nil.
	
	"We put a proxy and become for B."
	proxy := ObjectProxy new.
	proxy become: b.
	
	3 timesRepeat: [Smalltalk garbageCollect].
	finalInstances := ClassWith1Var instanceCount. 
	"Since nobody else point to B after the become, D an C should be garbage collected"
	self assert: finalInstances = (initialInstances - 2). 
	

	self assert: a var1 = b.
	"With this, using the DNU the proxy will load back the objects"
	self assert: (a var1 first var1 = hello).
	self assert: (a var1 last var1 = today).
	self assert:  ClassWith1Var instanceCount = initialInstances.! !

!ObjectProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 10/22/2010 17:01'!
testAllNomralObjectsInnerAndShared
	"A points to B which is an array that points to C and D. All are normal and inner objects"	
	| c d b a proxy fileName hello today initialInstances finalInstances |
	
	hello := 'Hello'.
	today := Date today.
	
	c := ClassWith1Var new var1: hello.
	d := ClassWith1Var new var1: today.
	b := Array with: c with: d.
	a := ClassWith1Var new var1: b.
	
	Smalltalk garbageCollect.
	initialInstances := ClassWith1Var instanceCount. 
	d :=  nil.
	"We only nil D. C is still pointing, thus, it is a shared object."
	
	"We put a proxy and become for B."
	proxy := ObjectProxy new.
	proxy become: b.
	
	Smalltalk garbageCollect.
	finalInstances := ClassWith1Var instanceCount. 
	"Since nobody else point to B after the become, D (C will not) should be garbage collected"
	self assert: finalInstances = (initialInstances - 1). 
	

	self assert: a var1 == b.
	"With this, using the DNU the proxy will load back the objects"
	self assert: (a var1 first var1 = hello).
	self assert: (a var1 last var1 = today).
	"We cannot get duplicates of C."
	self assert:  ClassWith1Var instanceCount = initialInstances.
! !

!ObjectProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 11/17/2010 20:10'!
testObjectProxyClassMessageEquality
	| proxy fileName anObject |
	
	anObject := ClassWith1Var new.
	anObject var1: 'something'.
	proxy := ObjectProxy new.
	
	self assert: anObject class == ClassWith1Var. 
	
	proxy become: anObject.
	
	"We should be always able to get the real class of an object, for out internal usage."
	self assert: anObject mareaClass == ObjectProxy.  
	self assert: (anObject mareaClass name = #ObjectProxy).
	
	self assert: anObject class == ClassWith1Var. 
	self assert: (anObject class name == #ClassWith1Var).
	"This will be useful for code like:
	[anObject class == ClassWith1Var] ifTrue: [ doSomething ]
	If this assert doesnt work, then that code will be broken."
	
	"I don't this a class will overried = but in such case, this should be true anyway:"
	self assert: anObject class = ClassWith1Var. 
	self assert: (anObject class name = #ClassWith1Var).
		
	self assert: (anObject var1 = 'something').
! !

!ObjectProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 11/17/2010 20:11'!
testObjectProxyClassMessageNextInstance
	| proxy fileName anObject |
	
	anObject := ClassWith1Var new.
	anObject var1: 'something'.
	proxy := ObjectProxy new.
	
	self assert: anObject class == ClassWith1Var. 
	
	proxy become: anObject.
	
	self assert: (ClassWith1Var someInstance class = ClassWith1Var).
	self assert: (anObject nextInstance class = ClassWith1Var).
	
	self assert: anObject class == ClassWith1Var. 
	self assert: (anObject class name = #ClassWith1Var).

	"Now....do we want that #class loads back the original object"
	anObject isByteString.
	
	self assert: (anObject var1 = 'something').
	self assert: anObject class = ClassWith1Var. 
	self assert: (anObject class name = #ClassWith1Var).
	! !

!ObjectProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 11/17/2010 21:23'!
testObjectProxyClassMethods
	| proxy fileName anObject |
	
	anObject := ClassWith1Var new.
	anObject var1: 'something'.
	proxy := ObjectProxy new.
	
	self assert: anObject class fooClass = 'fooClass'.

	proxy become: anObject.
	
	"Even if the object was swapped, the class has to understand fooClass"
	self assert: anObject class == ClassWith1Var. 
	self assert: anObject class fooClass = 'fooClass'.
	
	self assert: (anObject class name = #ClassWith1Var).

	self assert: (anObject var1 = 'something').
	! !

!ObjectProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 11/17/2010 21:24'!
testObjectProxyClassMethods2
	| proxy fileName anObject |
	
	anObject := ClassWith1Var new.
	anObject var1: 'something'.
	proxy := ObjectProxy new.
	
	self assert: anObject class fooClass = 'fooClass'.

	proxy become: anObject.
	
	"Even if the object was swapped, the class has to understand fooClass"
	self assert: ClassWith1Var fooClass = 'fooClass'.
	self assert: anObject class == ClassWith1Var. 
	self assert: (anObject class name = #ClassWith1Var).

	self assert: (anObject var1 = 'something').
	! !

!ObjectProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 10/17/2010 20:43'!
testOneSingleObject
	| proxy fileName anObject |
	
	anObject := 'Hello'.
	
	"We put a proxy and become for B."
	proxy := ObjectProxy new.
	
	proxy become: anObject.
	
	self assert: (anObject class name = #ObjectProxy).
	
	anObject isByteString.
	"With this, using the DNU the proxy will load back the objects"
	self assert: (anObject = 'Hello').
	self assert: (anObject class name = 'Hello' class name).
	! !

!ObjectProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 10/21/2010 16:12'!
testOneSingleObjectProxyUndetstandsDNU
	"The object that we swap does also understand the message doesNotUnderstand. We have to be sure not to loop and to correctly call both doesNotUnderstand:"
	| proxy fileName anObject |
	
	anObject := ClassWithDNU new.
	
	proxy := ObjectProxy new.
	proxy become: anObject.
	
	self assert: (anObject class name = #ObjectProxy).
	self assert: anObject fooSomething = 'fooSomethingProxy'.
	self assert: (anObject class name = #ObjectProxy).
	
	self assert: (anObject perform: #unExistentMethod) = 'dnu'.
	self assert: (anObject class name =  ClassWithDNU name).
	
	! !

!ObjectProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 10/17/2010 21:05'!
testOneSingleObjectProxyUndetstandsMessage
	"The proxy does understand the message fooSomething. This can be a problem and this is why proxies should subclass from ProtoObject."
	| proxy fileName anObject |
	
	anObject := 'Hello'.
	
	"We put a proxy and become for B."
	proxy := ObjectProxy new.
	proxy become: anObject.
	
	self assert: (anObject class name = #ObjectProxy).
	self assert: anObject fooSomething = 'fooSomethingProxy'.
	self assert: (anObject class name = #ObjectProxy).
	
	anObject isByteString.
	self assert: (anObject class name =  'Hello' class name).
	
	! !

!ObjectProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 10/21/2010 18:47'!
testOneSingleObjectProxyUndetstandsMessageOverridden
	"The proxy does understand the message fooSomething, but the original class also understand fooSomething. In this test we can see this is a problem, since the fooSomething of the proxy will be executed instead of the one of the original objects, generating random problems. To avoid this problem, we named all of our proxy methods names, with a special prefix."
	| proxy fileName anObject |
	
	anObject := ClassWith1Var new .
	
	"We put a proxy and become for B."
	proxy := ObjectProxy new.
	proxy become: anObject.
	
	self assert: (anObject class name = #ObjectProxy).
	"this is the problem. We should have 'fooSomething' as an answer, and not 'fooSomethingProxy'. " 
	self assert: anObject fooSomething = 'fooSomethingProxy'.
	self assert: (anObject class name = #ObjectProxy).
	
	anObject foo.
	self assert: (anObject class name =  ClassWith1Var name).
	
	! !

!ObjectProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 10/21/2010 16:15'!
testOneSingleObjectProxyWithDNU
	"The object that we swap does not understand a the message. This should swap in the object, then thrown DNU error."
	| proxy fileName anObject |
	
	anObject := ClassWith1Var new.
	
	proxy := ObjectProxy new.
	proxy become: anObject.
	
	self assert: (anObject class name = #ObjectProxy).
	self assert: anObject fooSomething = 'fooSomethingProxy'.
	self assert: (anObject class name = #ObjectProxy).
	
	self should: [(anObject perform: #unExistentMethod)] raise: Error.
	self assert: (anObject class name =  ClassWith1Var name).
	
	
! !

!ObjectProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 10/17/2010 20:32'!
testOneSingleObjectSpecialBytecodes
	| proxy fileName anObject |
	
	anObject := 'Hello'.
	
	"We put a proxy and become for B."
	proxy := ObjectProxy new.
	proxy become: anObject.
	
	self assert: (anObject class name = #ObjectProxy).
	self assert: anObject fooSomething = 'fooSomethingProxy'.
	self assert: (anObject class name = #ObjectProxy).
	
	anObject class.
	self assert: (anObject class name = #ObjectProxy).
	
	anObject isByteString.
	self assert: (anObject class name =  'Hello' class name).
	
	! !

!ObjectProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 10/19/2010 13:01'!
testOneSingleObjectSpecialSelector
	| proxy fileName anObject |
	
	anObject := 1.5.
	
	"We put a proxy and become for B."
	proxy := ObjectProxy new.
	
	proxy become: anObject.
	
	self assert: (anObject class name = #ObjectProxy).
	
	anObject + 3.2.
	"With this, using the DNU the proxy will load back the objects"
	self assert: (anObject = 1.5).
	self assert: (anObject class name = 1.5 class name).
	! !

!ObjectProxy methodsFor: '*ProxiesTests' stamp: 'MarianoMartinezPeck 11/17/2010 20:11'!
class
	self mareaLog: 'Will restore object'.
	self become: self mareaLoadBackSerializedObjectsFromFile.
	self mareaLog: 'Object was restored'.
	^ self class! !

!ObjectProxy methodsFor: '*ProxiesTests' stamp: 'MarianoMartinezPeck 10/17/2010 19:13'!
fooSomething
	^ 'fooSomethingProxy'! !
